;
; MINICHESS 850
; ̐ݒE
;
.area _CODE

;
; LO()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,E,HL:j
;
.if PUTCTRL
put_ctrl_wking::
	; LÖʒuݒ肷
	ld HL, #pos_wking
	ld (HL), E
.else
remove_ctrl_wking::
	ld H, #CTRL_W_H
.endif
put_ctrl_king:
	; LO̗ݒ肷
	ld A, #DIR_SW
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	call _put_ctrl_pos
	inc E
	call _put_ctrl_pos
	ld A, #PITCH - 2
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	inc E
	call _put_ctrl_pos
	ld A, #PITCH - 2
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	call _put_ctrl_pos
	inc E
	jp _put_ctrl_pos

;
; LO()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,E,HL:j
;
.if PUTCTRL
put_ctrl_bking::
	; LÖʒuݒ肷
	ld HL, #pos_bking
	ld (HL), E
.else
remove_ctrl_bking::
	ld H, #CTRL_B_H
.endif
	; LO̗ݒ肷
	jp put_ctrl_king

;
; iCg()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,E,HL:j
;
.if PUTCTRL
put_ctrl_wknight::
.else
remove_ctrl_wknight::
.endif
	; iCg̐ݒ肷
	ld HL, #count_wknight
put_ctrl_knight:
.if PUTCTRL
	inc (HL)

	; ]l()ݒ肷
	ld A, #POINT_KNIGHT
.else
	dec (HL)

	; ]l()ݒ肷
	ld A, #-POINT_KNIGHT
.endif
	ld L, #EVAL_H_L
	add (HL)
	ld (HL), A

	; iCg̗ݒ肷
	ld A, #DIR_SW + DIR_S
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	inc E
	call _put_ctrl_pos
	ld A, #PITCH - 3
	add E
	ld E, A
	call _put_ctrl_pos
	ld A, #4
	add E
	ld E, A
	call _put_ctrl_pos
	ld A, #PITCH * 2 - 4
	add E
	ld E, A
	call _put_ctrl_pos
	ld A, #4
	add E
	ld E, A
	call _put_ctrl_pos
	ld A, #PITCH - 3
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	inc E
	jp _put_ctrl_pos

;
; iCg()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,E,HL:j
;
.if PUTCTRL
put_ctrl_bknight::
	ld HL, #count_bknight
.else
remove_ctrl_bknight::
	ld HL, #count_bknight
.endif
	jp put_ctrl_knight

;
; |[()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,E,HL:j
;
.if PUTCTRL
put_ctrl_wpawn::
	; |[̐ݒ肷
	ld HL, #count_wpawn
	inc (HL)

	; ]l()ݒ肷
	ld L, #EVAL_H_L
	inc (HL)

	; 1ŏiłs𓾂
	ld A, (#rank_pre)
	ld C, A

	; 1ŏiłꍇ͕]lグ
	ld A, E
	cp C
	jp C, put_ctrl_wpawn_skip2
	inc (HL)
put_ctrl_wpawn_skip2:

	; OiƂ]lグ
	ld L, #EVAL_L_L
	rrca
	rrca
	rrca
	and #0x07
	sub #3
	add (HL)
	ld (HL), A
.else
remove_ctrl_wpawn::
	; |[̐ݒ肷
	ld HL, #count_wpawn
	dec (HL)

	; ]l()ݒ肷
	ld L, #EVAL_H_L
	dec (HL)

	; 1ŏiłs𓾂
	ld A, (#rank_pre)
	ld C, A

	; 1ŏiłꍇ͕]lグ
	ld A, E
	cp C
	jp C, remove_ctrl_wpawn_skip2
	dec (HL)
remove_ctrl_wpawn_skip2:

	; OiƂ]lグ
	ld L, #EVAL_L_L
	rrca
	rrca
	rrca
	and #0x07
	sub #3
	neg
	add (HL)
	ld (HL), A
.endif

	; ݒ肷
	ld A, #DIR_NW
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	inc E
	call _put_ctrl_pos

	; O󂢂Ăꍇ͕]lグ
	dec E
	ld A, (DE)
	or A
	ret NZ

	ld L, #EVAL_L_L
.if PUTCTRL
	inc (HL)
.else
	dec (HL)
.endif
	ret

;
; |[()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,E,HL:j
;
.if PUTCTRL
put_ctrl_bpawn::
	; |[̐ݒ肷
	ld HL, #count_bpawn
	inc (HL)

	; ]l()ݒ肷
	ld L, #EVAL_H_L
	inc (HL)

	; Ղ̍𓾂
	ld A, (#height)
	ld C, A

	; 1ŏiłꍇ͕]lグ
	ld A, E
	cp #POS_A3
	jp NC, put_ctrl_bpawn_skip2
	inc (HL)
put_ctrl_bpawn_skip2:

	; OiƂ]lグ
	rrca
	rrca
	rrca
	and #0x07
	neg
	add C
	ld L, #EVAL_L_L
	add (HL)
	ld (HL), A
.else
remove_ctrl_bpawn::
	; |[̐ݒ肷
	ld HL, #count_bpawn
	dec (HL)

	; ]l()ݒ肷
	ld L, #EVAL_H_L
	dec (HL)

	; Ղ̍𓾂
	ld A, (#height)
	ld C, A

	; 1ŏiłꍇ͕]lグ
	ld A, E
	cp #POS_A3
	jp NC, remove_ctrl_bpawn_skip2
	dec (HL)
remove_ctrl_bpawn_skip2:

	; OiƂ]lグ
	rrca
	rrca
	rrca
	and #0x07
	neg
	add C
	neg
	ld L, #EVAL_L_L
	add (HL)
	ld (HL), A
.endif

	; ݒ肷
	ld A, #DIR_SW
	add E
	ld E, A
	call _put_ctrl_pos
	inc E
	inc E
	call _put_ctrl_pos

	; O󂢂Ăꍇ͕]lグ
	dec E
	ld A, (DE)
	or A
	ret NZ

	ld L, #EVAL_L_L
.if PUTCTRL
	inc (HL)
.else
	dec (HL)
.endif
	ret

;
; rVbv()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
.if PUTCTRL
put_ctrl_wbishop::
.else
remove_ctrl_wbishop::
.endif
	; rVbv̐ݒ肷
	ld HL, #count_wbishop
put_ctrl_bishop:
.if PUTCTRL
	inc (HL)

	; ]l()ݒ肷
	ld A, #POINT_BISHOP
.else
	dec (HL)

	; ]l()ݒ肷
	ld A, #-POINT_BISHOP
.endif
	ld L, #EVAL_H_L
	add (HL)
	ld (HL), A

	; rVbv̗ݒ肷
	ld C, #DIR_NW
	call _put_ctrl_dir
	ld C, #DIR_NE
	call _put_ctrl_dir
	ld C, #DIR_SW
	call _put_ctrl_dir
	ld C, #DIR_SE
	jp _put_ctrl_dir

;
; rVbv()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
.if PUTCTRL
put_ctrl_bbishop::
.else
remove_ctrl_bbishop::
.endif
	ld HL, #count_bbishop
	jp put_ctrl_bishop

;
; [N()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
.if PUTCTRL
put_ctrl_wrook::
.else
remove_ctrl_wrook::
.endif
	; [N̐ݒ肷
	ld HL, #count_wrook
put_ctrl_rook:
.if PUTCTRL
	inc (HL)

	; ]l()ݒ肷
	ld A, #POINT_ROOK
.else
	dec (HL)

	; ]l()ݒ肷
	ld A, #-POINT_ROOK
.endif
	ld L, #EVAL_H_L
	add (HL)
	ld (HL), A

	; [N̗ݒ肷
	ld C, #DIR_N
	call _put_ctrl_dir
	ld C, #DIR_W
	call _put_ctrl_dir
	ld C, #DIR_E
	call _put_ctrl_dir
	ld C, #DIR_S
	jp _put_ctrl_dir

;
; [N()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
.if PUTCTRL
put_ctrl_brook::
.else
remove_ctrl_brook::
.endif
	ld HL, #count_brook
	jp put_ctrl_rook

;
; NB[()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
.if PUTCTRL
put_ctrl_wqueen::
.else
remove_ctrl_wqueen::
.endif
	; NB[̐ݒ肷
	ld HL, #count_wqueen
put_ctrl_queen:
.if PUTCTRL
	inc (HL)

	; ]l()ݒ肷
	ld A, #POINT_QUEEN
.else
	dec (HL)

	; ]l()ݒ肷
	ld A, #-POINT_QUEEN
.endif
	ld L, #EVAL_H_L
	add (HL)
	ld (HL), A

	; NB[̗ݒ肷
	ld C, #DIR_NW
	call _put_ctrl_dir
	inc C
	call _put_ctrl_dir
	inc C
	call _put_ctrl_dir
	ld C, #DIR_W
	call _put_ctrl_dir
	inc C
	inc C
	call _put_ctrl_dir
	ld C, #DIR_SW
	call _put_ctrl_dir
	inc C
	call _put_ctrl_dir
	inc C
	jp _put_ctrl_dir

;
; NB[()̗ݒ肷 (put_piece, remove_piecẻ)
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
.if PUTCTRL
put_ctrl_bqueen::
.else
remove_ctrl_bqueen::
.endif
	ld HL, #count_bqueen
	jp put_ctrl_queen

;
; w肵ėݒ肷 ()
;
; 
; C:
; DE:Տ̈ʒu
; HL:̈ʒu
;
; o
; AF,B,L:j
;
_put_ctrl_dir:
.if PUTCTRL
put_ctrl_dir::
.else
remove_ctrl_dir::
.endif
	push DE

	; ̐𓾂
	ld L, #EVAL_L_L
	ld B, (HL)

_put_ctrl_dir_loop:
	; w̕ɐi߂
	ld A, E
	add C
	ld E, A

	; 邩?
	ld A, (DE)
	or A
	jp NZ, _put_ctrl_dir_last

	; ݒ肷
	ld L, E
.if PUTCTRL
	inc (HL)
	inc B
.else
	dec (HL)
	dec B
.endif
	jp _put_ctrl_dir_loop

_put_ctrl_dir_last:
	; ̐
	ld L, #EVAL_L_L
	ld (HL), B

	; I[̗ݒ肷
	cp #WALL
	call NZ, _put_ctrl_pos_skip

	pop DE
	ret

;
; ʒuw肵ėݒ肷 ()
;
; 
; A:
; DE:Տ̈ʒu
; H:̈ʒu()
;
; o
; AF,L:j
;
_put_ctrl_pos:
	; ǂ?
	ld A, (DE)
	cp #WALL
	ret Z

	; ]l()ݒ肷
	ld L, #EVAL_L_L
_put_ctrl_pos_skip:
.if PUTCTRL
	inc (HL)
.else
	dec (HL)
.endif

	ld L, E
.if PUTCTRL
	; ݒ肷
	inc (HL)

	; ȂȂ߂
	or A
	ret Z

	; 1łȂΖ߂
	ld L, (HL)
	dec L
	ret NZ
.else
	; ݒ肷
	dec (HL)

	; 0łȂΖ߂
	ret NZ

	; ȂȂ߂
	or A
	ret Z
.endif

	; ǂ̋邩?
	rlca
	jp C, _put_ctrl_pos_guard_b

_put_ctrl_pos_guard_w:
	; ̃LOȂ߂
	cp #PIECE_KING * 2 + PLAYER_WHITE * 2
	ret Z

	; vC[łȂȂ߂
	ld A, H
	dec A
	cp D
	ret NZ

	; ]l()ݒ肷
	ld L, #EVAL_L_L
.if PUTCTRL
	inc (HL)
.else
	dec (HL)
.endif
	ret

_put_ctrl_pos_guard_b:
	; ̃LOȂ߂
	cp #PIECE_KING * 2 + 0x01
	ret Z

	; vC[łȂȂ߂
	ld A, H
	dec A
	dec A
	cp D
	ret NZ

	; ]l()ݒ肷
	ld L, #EVAL_L_L
.if PUTCTRL
	inc (HL)
.else
	dec (HL)
.endif
	ret

;
; Copyright 2017 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
