;
; MINICHESS 850
; uE菜
;
.area _CODE

.if PUTPIECE
;
; u
;
; 
; A:
; DE:Տ̈ʒu
;
; o
; AF,AF',BC,DE,L:j
;
put_piece::
.else
;
; 菜
;
; 
; DE:Տ̈ʒu
;
; o
; AF,BC,DE,L:j
;
remove_piece::
.endif
.if PUTPIECE
	ex AF, AF'
.endif
	; XV
	ld HL, #rnd
	ld A, E
	xor (HL)
	ld (HL), A

	; e󂯂闘Đݒ肷
	ld L, E
	inc H
	ld A, (HL)
	inc H
	add (HL)
	call NZ, reset_ctrl

.if PUTPIECE
	ex AF, AF'
.endif

	; u ܂ 菜
	ld H, D
	ld L, E
.if PUTPIECE
	ld (HL), A
.else
	ld A, (HL)
	ld (HL), #0
.endif
	ld B, A

	; |[()̑OȂΕ]lݒ肷
	ld A, E
	add #DIR_S
	ld L, A
	ld A, (HL)
	cp #PIECE_WPAWN
	jp NZ, put_piece_skip1
	inc H
	ld L, #EVAL_L_L
.if PUTPIECE
	dec (HL)
.else
	inc (HL)
.endif
	ld H, D
put_piece_skip1:

	; |[()̑OȂΕ]lݒ肷
	ld A, E
	add #DIR_N
	ld L, A
	ld A, (HL)
	cp #PIECE_BPAWN
	jp NZ, put_piece_skip2
	inc H
	inc H
	ld L, #EVAL_L_L
.if PUTPIECE
	dec (HL)
.else
	inc (HL)
.endif
put_piece_skip2:

	; ̗ݒ肷
	ld A, B
	rlca
	jp C, put_bpiece
put_wpiece:
	cp #PIECE_PAWN * 2 + 0x80
.if PUTPIECE
	jp Z, put_ctrl_wpawn
.else
	jp Z, remove_ctrl_wpawn
.endif
	cp #PIECE_KNIGHT * 2 + 0x80
.if PUTPIECE
	jp Z, put_ctrl_wknight
.else
	jp Z, remove_ctrl_wknight
.endif
	cp #PIECE_KING * 2 + 0x80
.if PUTPIECE
	jp Z, put_ctrl_wking
.else
	jp Z, remove_ctrl_wking
.endif
	cp #PIECE_BISHOP * 2 + 0x80
.if PUTPIECE
	jp Z, put_ctrl_wbishop
.else
	jp Z, remove_ctrl_wbishop
.endif
	cp #PIECE_ROOK * 2 + 0x80
.if PUTPIECE
	jp Z, put_ctrl_wrook
.else
	jp Z, remove_ctrl_wrook
.endif
	cp #PIECE_QUEEN * 2 + 0x80
.if PUTPIECE
	jp Z, put_ctrl_wqueen
put_wpiece_err::
	rst 0x30 ; DEBUG
	ret
.else
	jp Z, remove_ctrl_wqueen
remove_wpiece_err::
	rst 0x30 ; DEBUG
	ret
.endif

put_bpiece:
	cp #PIECE_PAWN * 2 + 0x01
.if PUTPIECE
	jp Z, put_ctrl_bpawn
.else
	jp Z, remove_ctrl_bpawn
.endif
	cp #PIECE_KNIGHT * 2 + 0x01
.if PUTPIECE
	jp Z, put_ctrl_bknight
.else
	jp Z, remove_ctrl_bknight
.endif
	cp #PIECE_KING * 2 + 0x01
.if PUTPIECE
	jp Z, put_ctrl_bking
.else
	jp Z, remove_ctrl_bking
.endif
	cp #PIECE_BISHOP * 2 + 0x01
.if PUTPIECE
	jp Z, put_ctrl_bbishop
.else
	jp Z, remove_ctrl_bbishop
.endif
	cp #PIECE_ROOK * 2 + 0x01
.if PUTPIECE
	jp Z, put_ctrl_brook
.else
	jp Z, remove_ctrl_brook
.endif
	cp #PIECE_QUEEN * 2 + 0x01
.if PUTPIECE
	jp Z, put_ctrl_bqueen
put_bpiece_err::
	rst 0x30 ; DEBUG
	ret
.else
	jp Z, remove_ctrl_bqueen
remove_bpiece_err::
	rst 0x30 ; DEBUG
	ret
.endif

;
; e󂯂闘Đݒ肷
;
; 
; DE:Տ̈ʒu
; HL:̗̈ʒu
;
; o
; AF,C,HL:j
;
reset_ctrl:
	; LO?
.if PUTPIECE
	ex AF, AF'
	cp #PIECE_BKING
	jp Z, reset_ctrl_skip3
	cp #PIECE_WKING
	jp Z, reset_ctrl_skip3
.else
	ld A, (DE)
	cp #PIECE_BKING
	jp Z, reset_ctrl_skip3
	cp #PIECE_WKING
	jp Z, reset_ctrl_skip3
.endif

	; ̈ʒu𓾂
	rlca
	jp C, reset_ctrl_skip1
	dec H
reset_ctrl_skip1:

	; ̗Ε]lݒ肷
	inc (HL)
	dec (HL)
	jp Z, reset_ctrl_skip2
	ld L, #EVAL_L_L
.if PUTPIECE
	inc (HL)
.else
	dec (HL)
.endif

	; AWX^̒l()߂
reset_ctrl_skip2:
.if PUTPIECE
	rrca
reset_ctrl_skip3:
	ex AF, AF'
.else
reset_ctrl_skip3:
.endif

	; e󂯂闘Đݒ肷
	ld C, #DIR_NW
	call reset_ctrl_bishop
	inc C
	call reset_ctrl_rook
	inc C
	call reset_ctrl_bishop
	ld C, #DIR_W
	call reset_ctrl_rook
	inc C
	inc C
	call reset_ctrl_rook
	ld C, #DIR_SW
	call reset_ctrl_bishop
	inc C
	call reset_ctrl_rook
	inc C

;
; uʉe󂯂闘Đݒ肷(rVbv܂̓NB[) (put_piece, remove_piecẻ)
;
; 
; C:`FbN
; DE:Տ̈ʒu
;
; o
; AF,HL:j
;
reset_ctrl_bishop:
	; 𓾂
	ld L, E
reset_ctrl_bishop_loop:
	ld A, E
	add C
	ld E, A
	ld A, (DE)
	or A
	jp Z, reset_ctrl_bishop_loop
	ld E, L

	; rVbv܂̓NB[?
	cp #PIECE_WBISHOP
	jp Z, reset_ctrl_w
	cp #PIECE_WQUEEN
	jp Z, reset_ctrl_w
	cp #PIECE_BBISHOP
	jp Z, reset_ctrl_b
	cp #PIECE_BQUEEN
	jp Z, reset_ctrl_b
	ret

;
; uʉe󂯂闘Đݒ肷([N܂̓NB[) (put_piece, remove_piecẻ)
;
; 
; C:`FbN
; DE:Տ̈ʒu
;
; o
; AF,HL:j
;
reset_ctrl_rook:
	; 𓾂
	ld L, E
reset_ctrl_rook_loop:
	ld A, E
	add C
	ld E, A
	ld A, (DE)
	or A
	jp Z, reset_ctrl_rook_loop
	ld E, L

	; [N܂̓NB[?
	cp #PIECE_WROOK
	jp Z, reset_ctrl_w
	cp #PIECE_WQUEEN
	jp Z, reset_ctrl_w
	cp #PIECE_BROOK
	jp Z, reset_ctrl_b
	cp #PIECE_BQUEEN
	jp Z, reset_ctrl_b
	ret

reset_ctrl_w:
	; ̗Đݒ肷
	ld H, #CTRL_W_H
	jp reset_ctrl_skip

reset_ctrl_b:
	; ̗Đݒ肷
	ld H, #CTRL_B_H

reset_ctrl_skip:
	; tɂ
	ld A, C
	neg
	ld C, A

.if PUTPIECE
	; 
	call remove_ctrl_dir
.else
	; ݒ肷
	call put_ctrl_dir
.endif

	; tɂ
	ld A, C
	neg
	ld C, A
	ret

;
; Copyright 2017 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
