;
; MINICHESS 850
; Rs[^̎vl
;
.area _CODE

; alpha-betaJbgLɂ邩?
ABCUT = 1

;
; `FbNĂ邩?
;
; 
; Ȃ
;
; o
; Cy:1
; Z:`FbNĂȂ, NZ:`FbNĂ
; HL:j
;
.if WHITE
is_checked_w::
.else
is_checked_b::
.endif
.if WHITE
	ld HL, #pos_wking
	ld L, (HL)
	inc H
.else
	ld HL, #pos_bking
	ld L, (HL)
	dec H
.endif
	inc (HL)
	dec (HL)
	scf
	ret

rand:
	.dw 0x100

;
; Rs[^̎𓾂 (think_white, think_black̉)
;
; 
; C:[
; IX:
; IY:̈ꗗ݈̏ʒu
; BC',DE',HL':̈ꗗ̏
;
; o
; DE:]l
; BC',DE',HL':̈ꗗ̏
; AF,DE,HL,AF':j
;
.if WHITE
think_w::
.else
think_b::
.endif
	; [łȂ?
	dec C
	jp NZ, think_tree

	; ]l()𓾂
	ld HL, #w_eval_l
	ld A, (HL)
	inc H
	sub (HL)
	ld E, A

	; ]l()𓾂
	dec H
	inc L
	ld A, (HL)
	inc H
	sub (HL)
	ld D, A

	; zĂ邩?
	ld A, OFF_POS_FROM(IX)
	cp -20 + OFF_POS_TO(IX)
	ret NZ
	ld A, OFF_POS_TO(IX)
	cp -20 + OFF_POS_FROM(IX)
	ret NZ
	ld A, -10 + OFF_POS_FROM(IX)
	cp -30 + OFF_POS_TO(IX)
	ret NZ
	ld A, -10 + OFF_POS_TO(IX)
	cp -30 + OFF_POS_FROM(IX)
	ret NZ

	; zĂꍇ͕]l0ɋ߂Â
	ld A, D
	cp #0
	jp P, think_rep_skip
	add #2
	ld D, A
	ret
think_rep_skip:
	sub #2
	ld D, A
	ret

think_tree:
	; T
	push IX
	push IY
	exx
	push BC
	push DE
	push HL
	push HL
	pop IX
	ld (HL), #0
	ld BC, #-3
	add IX, BC
	ld BC, #10
	add IY, BC
	xor A
	ld C, A
	exx

	; ]l̏lݒ肷
	ld OFF_POS_FROM(IY), A
.if WHITE
	ld OFF_EVAL_H(IY), #-MAX_EVAL
.else
	ld OFF_EVAL_H(IY), #MAX_EVAL
.endif

	; io[\邩?
	ld A, (#lv)
	dec A
	cp C
	jp NZ, think_nobar

	; io[\
	ld A, (#width)
	add #3
	ld E, A
	ld D, #5

	ld HL, #tick
	ld A, (HL)
	inc L
	add (HL)
	ld (HL), A

	rlca
	rlca
	rlca
	and #0x07
	add #0x80
	call putchr
	ld HL, #msg_thinking
	call print_str
think_nobar:

	; ̈ꗗ𐶐
.if WHITE
	call make_move_list_w
.else
	call make_move_list_b
.endif
	jp Z, think_last
	ld B, A

	; ̎̐̍ő吔ȓ?
	ld HL, #pruning - 1
	ld A, C
	add L
	ld L, A
	ld A, (HL)
	cp B
	jp NC, think_first

	; LO`FbNĂꍇ͑O}肵Ȃ
.if WHITE
	ld HL, #pos_wking
	ld L, (HL)
	ld H, #CTRL_B_H
.else
	ld HL, #pos_bking
	ld L, (HL)
	ld H, #CTRL_W_H
.endif
	inc (HL)
	dec (HL)
	jp NZ, think_first

	; ̎̐𐧌(O})
	ld B, A

think_first:
	push BC

.if DEBUG
	; \Ȏ肩? (eXg)
	ld L, OFF_POS_FROM(IX)
	ld H, #BOARD_H
	ld A, (HL)
	and #MASK_PLAYER
.if WHITE
	cp #PLAYER_WHITE
.else
	cp #PLAYER_BLACK
.endif
	call NZ, think_err
.endif

	; 𓮂()
	call play
	jp think_skip

think_loop:
	; ړOƓ?
	ld A, OFF_POS_FROM(IX)
	cp 4 + OFF_POS_FROM(IX)
	jp NZ, think_undo_play

	push BC

	; ߂ē
	ld BC, #4
	add IX, BC
	call replay
	jp think_skip

think_undo_play:
	push BC

	; ߂
	call undo

	; 𓮂
	ld BC, #4
	add IX, BC
	call play

think_skip:
	pop BC

	; LOɑ̗邩?
.if WHITE
	ld HL, #pos_wking
	ld L, (HL)
	inc H
.else
	ld HL, #pos_bking
	ld L, (HL)
	dec H
.endif
	inc (HL)
	dec (HL)
	jp NZ, think_next

	; ɎԂn
	push BC
.if ABCUT
	; abl̏lݒ肷
	ld A, OFF_ALPHA_L(IY)
	ld 10 + OFF_ALPHA_L(IY), A
	ld A, OFF_ALPHA_H(IY)
	ld 10 + OFF_ALPHA_H(IY), A
	ld A, OFF_BETA_L(IY)
	ld 10 + OFF_BETA_L(IY), A
	ld A, OFF_BETA_H(IY)
	ld 10 + OFF_BETA_H(IY), A
.endif
.if WHITE
	call think_b
.else
	call think_w
.endif
	pop BC

.if TEST_LEAVES
	; t̐߂(eXg)
	push HL
	ld HL, (#leaves)
	inc HL
	ld (#leaves), HL
	pop HL
.endif

	; ]lr
.if WHITE
	ld A, D
	cp OFF_EVAL_H(IY)
.else
	ld A, OFF_EVAL_H(IY)
	cp D
.endif
	jp M, think_next
	jp NZ, think_upd

.if WHITE
	ld A, OFF_EVAL_L(IY)
	sub E
	jp P, think_next
.else
	ld A, E
	sub OFF_EVAL_L(IY)
	jp P, think_next
.endif

think_upd:
	; ]lݒ肷
	ld OFF_EVAL_L(IY), E
	ld OFF_EVAL_H(IY), D
	ld A, OFF_POS_FROM(IX)
	ld OFF_POS_FROM(IY), A
	ld A, OFF_POS_TO(IX)
	ld OFF_POS_TO(IY), A
	ld A, OFF_PRO(IX)
	ld OFF_PRO(IY), A

.if ABCUT
	; ablݒ肷
.if WHITE
	ld OFF_ALPHA_L(IY), E
	ld OFF_ALPHA_H(IY), D
	ld A, D
.else
	ld OFF_BETA_L(IY), E
	ld OFF_BETA_H(IY), D
	ld A, OFF_ALPHA_H(IY)
.endif

	; Jbg?
	cp OFF_BETA_H(IY)
	jp M, think_next
	jp NZ, think_cut
.if WHITE
	ld A, E
.else
	ld A, OFF_ALPHA_L(IY)
.endif
	cp OFF_BETA_L(IY)
	jp M, think_next

think_cut:
	; Jbg
	push BC
	call undo
	pop BC

.if WHITE
	ld E, OFF_BETA_L(IY)
	ld D, OFF_BETA_H(IY)
.else
	ld E, OFF_ALPHA_L(IY)
	ld D, OFF_ALPHA_H(IY)
.endif
	jp think_last_ab
.endif

think_next:
	dec B
	jp NZ, think_loop 

	push BC
	call undo
	pop BC

think_last:
	; ŗǂ̕]l߂
	ld E, OFF_EVAL_L(IY)
	ld D, OFF_EVAL_H(IY)

	; Cg?
	ld A, OFF_POS_FROM(IY)
	or A
	jp NZ, think_last_ab

	; 󂢂قǕ]lȂ悤ɂ
	ld A, C
	srl A
.if WHITE
	neg
	add D
	ld D, A
	inc D
	inc D
	inc D
.else
	add D
	ld D, A
	dec D
	dec D
	dec D
.endif

	; `FbNCg?
.if WHITE
	ld HL, #pos_wking
.else
	ld HL, #pos_bking
.endif
	ld L, (HL)
.if WHITE
	ld H, #CTRL_B_H
.else
	ld H, #CTRL_W_H
.endif
	inc (HL)
	dec (HL)
	jp NZ, think_last_ab

	; XeCCg
	ld DE, #0x0000

think_last_ab:
	exx
	pop HL
	pop DE
	pop BC
	exx
	pop IY
	pop IX
	ret

.if DEBUG
think_err:
.if WHITE
think_w_err::
.else
think_b_err::
.endif
	rst 0x30 ; DEBUG
	ret
.endif

;
; ̈ꗗ𐶐
;
; 
; BC',DE',HL':ꗗ̏
;
; o
; A:̐
; Z:̌Ȃ, NZ:
; BC',DE',HL':ꗗ̏
; BC,DE,HL,AF':j
;
.if WHITE
make_move_list_w::
.else
make_move_list_b::
.endif
	ld DE, #BOARD_H * 0x100 + POS_A1
	ld H, D

.if DEBUG
	; eXg
	exx
	ld A, (HL)
	or A
	exx
	call NZ, make_move_list_err
.endif

	; mCY
	ld A, (#rnd)
	ld (#noise), A

make_move_list_loop:
	; ꂪ̌
	ld A, (DE)
	or A
	call NZ, make_list_ins

	; ̃}Xɐi
	inc E
	ld A, E
	cp #POS_F6 + 1
	jp NZ, make_move_list_loop

	; ̌̐𓾂
	exx
	ld A, C
	exx
	srl A
	srl A
	ret

make_list_ins:
	cp #WALL
	ret Z
.if WHITE
	cp #PIECE_WPAWN
	jp Z, ins_move_pawn
	cp #PIECE_WKNIGHT
	jp Z, ins_move_knight
	cp #PIECE_WBISHOP
	jp Z, ins_move_bishop
	cp #PIECE_WROOK
	jp Z, ins_move_rook
	cp #PIECE_WQUEEN
	jp Z, ins_move_queen
	cp #PIECE_WKING
	jp Z, ins_move_king
.else
	cp #PIECE_BPAWN
	jp Z, ins_move_pawn
	cp #PIECE_BKNIGHT
	jp Z, ins_move_knight
	cp #PIECE_BBISHOP
	jp Z, ins_move_bishop
	cp #PIECE_BROOK
	jp Z, ins_move_rook
	cp #PIECE_BQUEEN
	jp Z, ins_move_queen
	cp #PIECE_BKING
	jp Z, ins_move_king
.endif
	ret

.if DEBUG
make_move_list_err:
	rst 0x30 ; DEBUG
	ret
.endif

;
; NB[̎} ()
;
; 
; C:vC[
; DE:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF,B,HL:j
;
ins_move_queen:
	ld B, #0

	ld A, #DIR_NW
	call ins_move_dir
	ld A, #DIR_N
	call ins_move_dir
	ld A, #DIR_NE
	call ins_move_dir
	ld A, #DIR_W
	call ins_move_dir
	ld A, #DIR_E
	call ins_move_dir
	ld A, #DIR_SW
	call ins_move_dir
	ld A, #DIR_S
	call ins_move_dir
	ld A, #DIR_SE
	jp ins_move_dir

;
; [N̎} ()
;
; 
; C:vC[
; DE:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF,B,HL:j
;
ins_move_rook:
	ld B, #0

	ld A, #DIR_N
	call ins_move_dir
	ld A, #DIR_W
	call ins_move_dir
	ld A, #DIR_E
	call ins_move_dir
	ld A, #DIR_S
	jp ins_move_dir

;
; rVbv̎} ()
;
; 
; C:vC[
; DE:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF,B,HL:j
;
ins_move_bishop:
	ld B, #0

	ld A, #DIR_NW
	call ins_move_dir
	ld A, #DIR_NE
	call ins_move_dir
	ld A, #DIR_SW
	call ins_move_dir
	ld A, #DIR_SE
ins_move_dir:
	ld L, E
ins_move_dir_loop:
	push AF
	add L
	ld L, A
	call ins_move
	pop AF
	inc (HL)
	dec (HL)
	jp Z, ins_move_dir_loop
	ret

;
; LO̎} ()
;
; 
; C:vC[
; DE:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF,B,HL:j
;
ins_move_king:
	ld B, #0

	ld A, E
	add #DIR_SW
	ld L, A
	call ins_move_k
	inc L
	call ins_move_k
	inc L
	call ins_move_k
	ld A, #PITCH - 2
	add L
	ld L, A
	call ins_move_k
	inc L
	inc L
	call ins_move_k
	ld A, #PITCH - 2
	add L
	ld L, A
	call ins_move_k
	inc L
	call ins_move_k
	inc L

ins_move_k:
	; ̗Α}Ȃ
.if WHITE
	inc H
.endif
	inc H
	inc (HL)
	dec (HL)
	ld H, D
	jp Z, ins_move
	ret

;
; iCg̎} ()
;
; 
; C:vC[
; DE:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF,B,HL:j
;
ins_move_knight:
	ld B, #0

	; O
	ld A, E
	add #DIR_SW + DIR_S
	ld L, A
	call ins_move

	; OE
	inc L
	inc L
	call ins_move

	; O
	ld A, #PITCH - 3
	add L
	ld L, A
	call ins_move

	; EO
	inc L
	inc L
	inc L
	inc L
	call ins_move

	; 
	ld A, #PITCH * 2 - 4
	add L
	ld L, A
	call ins_move

	; E
	inc L
	inc L
	inc L
	inc L
	call ins_move

	; E
	ld A, #PITCH - 1
	add L
	ld L, A
	call ins_move

	; ㍶
	dec L
	dec L
	jp ins_move

;
; |[̎} ()
;
; 
; DE:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF,B,HL:j
;
ins_move_pawn:
.if WHITE
	; 1ŏiłs𓾂
	ld A, (#rank_pre)
	ld B, A

	; i邩?
	ld A, E
	cp B
	ld B, #0
	jp C, ins_move_pawn_skip

	; NB[ɏi
	push DE
	ld B, #PIECE_WQUEEN
	call ins_move_pawn_skip
	pop DE

	; iCgɏi
	ld B, #PIECE_WKNIGHT
.else
	; i邩?
	ld A, E
	cp #POS_A3
	ld B, #0
	jp NC, ins_move_pawn_skip

	; NB[ɏi
	push DE
	ld B, #PIECE_BQUEEN
	call ins_move_pawn_skip
	pop DE

	; iCgɏi
	ld B, #PIECE_BKNIGHT
.endif

ins_move_pawn_skip:
	; ΂ߑO
.if WHITE
	ld A, #DIR_NW
.else
	ld A, #DIR_SW
.endif
	add E
	ld L, A
	call ins_move_pawn2

	; E΂ߑO
	inc L
	inc L
	call ins_move_pawn2

	; 
	dec L

	; (O)Ȃ?
	inc (HL)
	dec (HL)
	ret NZ
	jp ins_move_skip

ins_move_pawn2:
	; (΂ߑO)̋邩?
	ld A, (HL)
	and #MASK_PLAYER
.if WHITE
	cp #PLAYER_BLACK
.else
	cp #PLAYER_WHITE
.endif
	ret NZ
	jp ins_move_skip

;
; } ()
;
; 
; B:i
; DE:ړ
; HL:ړ
; BC',DE',HL':ꗗ̏
;
; o
; BC',DE',HL':ꗗ̏
; AF:j
;
ins_move:
	; ̋܂͕ǂ邩?
.if WHITE
	ld A, #PLAYER_WHITE
.else
	ld A, #PLAYER_BLACK
.endif
	and (HL)
	ret NZ

ins_move_skip:
	; ړɃLO邩?
	ld A, (HL)
	and #MASK_PIECE
	cp #PIECE_KING
	ret Z

	; Dx𓾂
	push BC
	push DE
	push HL

	; 
	xor A
	ld (#sum), A

	; i
	push HL

	ld C, #0

	; |[?
	ld A, (DE)
.if WHITE
	cp #PIECE_WPAWN
.else
	cp #PIECE_BPAWN
.endif
	jp NZ, ins_move_no_pro

	; ړ悪ł?
	ld A, L
.if WHITE
	push HL
	ld HL, #rank_pro
	sub (HL)
	pop HL
.else
	sub #POS_A1
.endif
	cp #8
	jp NC, ins_move_no_pro

	; ړɑ̗邩?
.if WHITE
	ld H, #CTRL_B_H
.else
	ld H, #CTRL_W_H
.endif
	inc (HL)
	dec (HL)
	jp NZ, ins_move_no_pro

	; i
	ld A, B
	and #MASK_PIECE
	ld C, A
	ld B, #0
	ld HL, #priority
	add HL, BC
	ld C, (HL)
ins_move_no_pro:

	ld A, C
	ld HL, #sum
	add (HL)
	ld (HL), A

	pop HL
	; i

	; ̗L
	push HL

	; ̗邩?
.if WHITE
	ld H, #CTRL_W_H
.else
	ld H, #CTRL_B_H
.endif
	inc (HL)
	dec (HL)
	jp Z, ins_move_no_guard
	inc A
ins_move_no_guard:

	; ̗邩?
.if WHITE
	inc H
.else
	dec H
.endif
	inc (HL)
	dec (HL)
	jp Z, ins_move_no_oppo_ctrl
	dec A
ins_move_no_oppo_ctrl:

	ld HL, #sum
	add (HL)
	ld (HL), A

	pop HL
	; ̗L

	; 
	push HL

	; ړ̋̓_𓾂
	ld A, (HL)
	and #MASK_PIECE
	ld C, A
	ld B, #0
	ld HL, #priority
	add HL, BC
	ld A, (HL)
	push AF

	; ړɑ̗邩?
.if WHITE
	ld H, #CTRL_B_H
.else
	ld H, #CTRL_W_H
.endif
	inc (HL)
	dec (HL)
	ld HL, #priority
	jp Z, ins_move_no_ctrl

	; ̋̓_𓾂
	ld A, (DE)
	and #MASK_PIECE
	ld C, A
	ld B, #0
	add HL, BC
ins_move_no_ctrl:

	; _̍𓾂
	pop AF
	sub (HL)

	ld HL, #sum
	add (HL)
	ld (HL), A

ins_move_no_cap:
	pop HL
	; 

	; LO𓮂?
	ld A, (DE)
	and #MASK_PIECE
	cp #PIECE_KING
	jp NZ, ins_move_not_king
	push HL
	ld HL, #sum
	dec (HL)
	pop HL
ins_move_not_king:
	; LO𓮂?

	; Oi
	; ړ̑LOƂ̋𓾂
	ld A, L
.if WHITE
	ld HL, #pos_bking
.else
	ld HL, #pos_bking
.endif
	sub (HL)
	jp P, ins_move_pos1
	neg
ins_move_pos1:
	and #0xf8
	ld B, A

	; ړȎLOƂ̋𓾂
	ld A, E
	sub (HL)
	jp P, ins_move_pos2
	neg
ins_move_pos2:
	and #0xf8

	; Oi?
	sub B
	ld A, #1
	jp NC, ins_move_fore
	xor A
ins_move_fore:
	; Oi

	; vmCY
	ld HL, #sum
	add (HL)
	ld HL, #noise
	rlc (HL)
	sbc #0
	rlc (HL)
	adc #0x40
	rlc (HL)
	rl A

	pop HL
	pop DE
	pop BC
	jp ins

.if DEBUG
.if WHITE
ins_move_w_err::
.else
ins_move_b_err::
.endif
	rst 0x30
	ret
.endif

; ̗Dx
priority:
	.db 0, 0, 9, 5, 3, 3, 1

; DxɉmCY
noise:
	.ds 1

; Dx̍v
sum:
	.ds 1

;
; Copyright 2017 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
